<?php
/**
 * Solar Generator Theme Customizer
 *
 * @package Solar Generator
 */

function Solar_Generator_Customize_register( $wp_customize ) {
	$wp_customize->get_setting( 'blogname' )->transport         = 'postMessage';
	$wp_customize->get_setting( 'blogdescription' )->transport  = 'postMessage';
	$wp_customize->get_setting( 'header_textcolor' )->transport = 'postMessage';

	if ( isset( $wp_customize->selective_refresh ) ) {
		$wp_customize->selective_refresh->add_partial(
			'blogname',
			array(
				'selector'        => '.site-title a',
				'render_callback' => 'Solar_Generator_Customize_partial_blogname',
			)
		);
		$wp_customize->selective_refresh->add_partial(
			'blogdescription',
			array(
				'selector'        => '.site-description',
				'render_callback' => 'Solar_Generator_Customize_partial_blogdescription',
			)
		);
	}

	/*
    * Theme Options Panel
    */
	$wp_customize->add_panel('solar_generator_panel', array(
		'priority' => 25,
		'capability' => 'edit_theme_options',
		'title' => __('Solar Generator Theme Options', 'solar-generator'),
	));

	/*
	* Customizer main header section
	*/

	$wp_customize->add_setting(
		'solar_generator_site_title_text',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => 1,
			'sanitize_callback' => 'solar_generator_sanitize_checkbox',
		)
	);

	$wp_customize->add_control(
		'solar_generator_site_title_text',
		array(
			'label'       => __('Enable Title', 'solar-generator'),
			'description' => __('Enable or Disable Title from the site', 'solar-generator'),
			'section'     => 'title_tagline',
			'type'        => 'checkbox',
		)
	);

	$wp_customize->add_setting(
		'solar_generator_site_tagline_text',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => 0,
			'sanitize_callback' => 'solar_generator_sanitize_checkbox',
		)
	);

	$wp_customize->add_control(
		'solar_generator_site_tagline_text',
		array(
			'label'       => __('Enable Tagline', 'solar-generator'),
			'description' => __('Enable or Disable Tagline from the site', 'solar-generator'),
			'section'     => 'title_tagline',
			'type'        => 'checkbox',
		)
	);

		$wp_customize->add_setting(
		'solar_generator_logo_width',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => '150',
			'sanitize_callback' => 'sanitize_text_field',
		)
	);

	$wp_customize->add_control(
		'solar_generator_logo_width',
		array(
			'label'       => __('Logo Width in PX', 'solar-generator'),
			'section'     => 'title_tagline',
			'type'        => 'number',
			'input_attrs' => array(
	            'min' => 100,
	             'max' => 300,
	             'step' => 1,
	         ),
		)
	);

	/* WooCommerce custom settings */

	$wp_customize->add_section('woocommerce_custom_settings', array(
		'priority'       => 5,
		'capability'     => 'edit_theme_options',
		'theme_supports' => '',
		'title'          => __('WooCommerce Custom Settings', 'solar-generator'),
		'panel'       => 'woocommerce',
	));

	$wp_customize->add_setting(
		'solar_generator_per_columns',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => '3',
			'sanitize_callback' => 'sanitize_text_field',
		)
	);

	$wp_customize->add_control(
		'solar_generator_per_columns',
		array(
			'label'       => __('Product Per Single Row', 'solar-generator'),
			'section'     => 'woocommerce_custom_settings',
			'type'        => 'number',
			'input_attrs' => array(
	            'min' => 1,
	             'max' => 4,
	             'step' => 1,
	         ),
		)
	);

	$wp_customize->add_setting(
		'solar_generator_product_per_page',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => '6',
			'sanitize_callback' => 'sanitize_text_field',
		)
	);

	$wp_customize->add_control(
		'solar_generator_product_per_page',
		array(
			'label'       => __('Product Per One Page', 'solar-generator'),
			'section'     => 'woocommerce_custom_settings',
			'type'        => 'number',
			'input_attrs' => array(
	            'min' => 1,
	             'max' => 12,
	             'step' => 1,
	         ),
		)
	);

	/*Related Products Enable Option*/
	$wp_customize->add_setting(
		'solar_generator_enable_related_product',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => 1,
			'sanitize_callback' => 'solar_generator_sanitize_checkbox',
		)
	);

	$wp_customize->add_control(
		'solar_generator_enable_related_product',
		array(
			'label'       => __('Enable Related Product', 'solar-generator'),
			'description' => __('Checked to show Related Product', 'solar-generator'),
			'section'     => 'woocommerce_custom_settings',
			'type'        => 'checkbox',
		)
	);

	$wp_customize->add_setting(
		'custom_related_products_number',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => '3',
			'sanitize_callback' => 'sanitize_text_field',
		)
	);

	$wp_customize->add_control(
		'custom_related_products_number',
		array(
			'label'       => __('Related Product Count', 'solar-generator'),
			'section'     => 'woocommerce_custom_settings',
			'type'        => 'number',
			'input_attrs' => array(
	            'min' => 1,
	             'max' => 20,
	             'step' => 1,
	         ),
		)
	);

	$wp_customize->add_setting(
		'custom_related_products_number_per_row',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => '3',
			'sanitize_callback' => 'sanitize_text_field',
		)
	);

	$wp_customize->add_control(
		'custom_related_products_number_per_row',
		array(
			'label'       => __('Related Product Per Row', 'solar-generator'),
			'section'     => 'woocommerce_custom_settings',
			'type'        => 'number',
			'input_attrs' => array(
	            'min' => 1,
	             'max' => 4,
	             'step' => 1,
	         ),
		)
	);

	/*Archive Product layout*/
	$wp_customize->add_setting('solar_generator_archive_product_layout',array(
        'default' => 'layout-1',
        'sanitize_callback' => 'solar_generator_sanitize_choices'
	));
	$wp_customize->add_control('solar_generator_archive_product_layout',array(
        'type' => 'select',
        'label' => esc_html__('Archive Product Layout','solar-generator'),
        'section' => 'woocommerce_custom_settings',
        'choices' => array(
            'layout-1' => esc_html__('Sidebar On Right','solar-generator'),
            'layout-2' => esc_html__('Sidebar On Left','solar-generator'),
			'layout-3' => esc_html__('Full Width Layout','solar-generator')
        ),
	) );

	/*Single Product layout*/
	$wp_customize->add_setting('solar_generator_single_product_layout',array(
        'default' => 'layout-1',
        'sanitize_callback' => 'solar_generator_sanitize_choices'
	));
	$wp_customize->add_control('solar_generator_single_product_layout',array(
        'type' => 'select',
        'label' => esc_html__('Single Product Layout','solar-generator'),
        'section' => 'woocommerce_custom_settings',
        'choices' => array(
            'layout-1' => esc_html__('Sidebar On Right','solar-generator'),
            'layout-2' => esc_html__('Sidebar On Left','solar-generator'),
			'layout-3' => esc_html__('Full Width Layout','solar-generator')
        ),
	) );

	$wp_customize->add_setting('solar_generator_woocommerce_product_sale',array(
		'capability'        => 'edit_theme_options',
		'transport'         => 'refresh',
        'default'           => 'Right',
        'sanitize_callback' => 'solar_generator_sanitize_choices'
    ));
    $wp_customize->add_control('solar_generator_woocommerce_product_sale',array(
        'label'       => esc_html__( 'Woocommerce Product Sale Positions','solar-generator' ),
        'type' => 'select',
        'section' => 'woocommerce_custom_settings',
        'choices' => array(
            'Right' => __('Right','solar-generator'),
            'Left' => __('Left','solar-generator'),
            'Center' => __('Center','solar-generator')
        ),
    ) );

	/*Additional Options*/
	$wp_customize->add_section('solar_generator_additional_section', array(
		'priority'       => 5,
		'capability'     => 'edit_theme_options',
		'theme_supports' => '',
		'title'          => __('Additional Options', 'solar-generator'),
		'panel'       => 'solar_generator_panel',
	));

	/*Main Slider Enable Option*/
	$wp_customize->add_setting(
		'solar_generator_enable_sticky_header',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => false,
			'sanitize_callback' => 'solar_generator_sanitize_checkbox',
		)
	);

	$wp_customize->add_control(
		'solar_generator_enable_sticky_header',
		array(
			'label'       => __('Enable Sticky Header', 'solar-generator'),
			'description' => __('Checked to enable sticky header', 'solar-generator'),
			'section'     => 'solar_generator_additional_section',
			'type'        => 'checkbox',
		)
	);

	/*Main Slider Enable Option*/
	$wp_customize->add_setting(
		'solar_generator_enable_preloader',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => 0,
			'sanitize_callback' => 'solar_generator_sanitize_checkbox',
		)
	);

	$wp_customize->add_control(
		'solar_generator_enable_preloader',
		array(
			'label'       => __('Enable Preloader', 'solar-generator'),
			'description' => __('Checked to show preloader', 'solar-generator'),
			'section'     => 'solar_generator_additional_section',
			'type'        => 'checkbox',
		)
	);
	
	/*Breadcrumbs Enable Option*/
	$wp_customize->add_setting(
		'solar_generator_enable_breadcrumbs',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => 1,
			'sanitize_callback' => 'solar_generator_sanitize_checkbox',
		)
	);

	$wp_customize->add_control(
		'solar_generator_enable_breadcrumbs',
		array(
			'label'       => __('Enable Breadcrumbs', 'solar-generator'),
			'description' => __('Checked to show Breadcrumbs', 'solar-generator'),
			'section'     => 'solar_generator_additional_section',
			'type'        => 'checkbox',
		)
	);

		/*Pagination Enable Option*/
	$wp_customize->add_setting(
		'solar_generator_enable_pagination',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => 1,
			'sanitize_callback' => 'solar_generator_sanitize_checkbox',
		)
	);

	$wp_customize->add_control(
		'solar_generator_enable_pagination',
		array(
			'label'       => __('Enable Pagination', 'solar-generator'),
			'description' => __('Checked to show Pagination', 'solar-generator'),
			'section'     => 'solar_generator_additional_section',
			'type'        => 'checkbox',
		)
	);

		/*Pagination Select Type Option*/
	$wp_customize->add_setting('solar_generator_pagination_type',array(
        'default' => 'type-1',
        'sanitize_callback' => 'solar_generator_sanitize_choices'
	));
	$wp_customize->add_control('solar_generator_pagination_type',array(
        'type' => 'select',
        'label' => esc_html__('Select Pagination Type','solar-generator'),
        'section' => 'solar_generator_additional_section',
        'choices' => array(
            'type-1' => esc_html__('Type 1','solar-generator'),
            'type-2' => esc_html__('Type 2','solar-generator'),
        ),
	) );

	/*Post layout*/
	$wp_customize->add_setting('solar_generator_archive_layout',array(
        'default' => 'layout-1',
        'sanitize_callback' => 'solar_generator_sanitize_choices'
	));
	$wp_customize->add_control('solar_generator_archive_layout',array(
        'type' => 'select',
        'label' => esc_html__('Posts Layout','solar-generator'),
        'section' => 'solar_generator_additional_section',
        'choices' => array(
            'layout-1' => esc_html__('Sidebar On Right','solar-generator'),
            'layout-2' => esc_html__('Sidebar On Left','solar-generator'),
			'layout-3' => esc_html__('Full Width Layout','solar-generator')
        ),
	) );

	/*single post layout*/
	$wp_customize->add_setting('solar_generator_post_layout',array(
        'default' => 'layout-1',
        'sanitize_callback' => 'solar_generator_sanitize_choices'
	));
	$wp_customize->add_control('solar_generator_post_layout',array(
        'type' => 'select',
        'label' => esc_html__('Single Post Layout','solar-generator'),
        'section' => 'solar_generator_additional_section',
        'choices' => array(
            'layout-1' => esc_html__('Sidebar On Right','solar-generator'),
            'layout-2' => esc_html__('Sidebar On Left','solar-generator'),
			'layout-3' => esc_html__('Full Width Layout','solar-generator')
        ),
	) );

	/*single page layout*/
	$wp_customize->add_setting('solar_generator_page_layout',array(
        'default' => 'layout-1',
        'sanitize_callback' => 'solar_generator_sanitize_choices'
	));
	$wp_customize->add_control('solar_generator_page_layout',array(
        'type' => 'select',
        'label' => esc_html__('Single Page Layout','solar-generator'),
        'section' => 'solar_generator_additional_section',
        'choices' => array(
            'layout-1' => esc_html__('Sidebar On Right','solar-generator'),
            'layout-2' => esc_html__('Sidebar On Left','solar-generator'),
			'layout-3' => esc_html__('Full Width Layout','solar-generator')
        ),
	) );

	$wp_customize->add_setting( 
		'solar_generator_additional_settings_upgraded_features',
		array(
			'sanitize_callback' => 'sanitize_text_field'
		)
	);

	$wp_customize->add_control(
		'solar_generator_additional_settings_upgraded_features', 
		array(
			'type'=> 'hidden',
			'description' => "
				<div class='customizer-upgraded-features'>
					<span class='pro-head'>Want more additional options?</span><br/>
					<span class='pro-text'>						
						<a target='_blank' href='". esc_url(SOLAR_GENERATOR_BUY_NOW) ." '>Check Solar Generator PRO version.</a>
					</div>
				</div>
			",
			'section' => 'solar_generator_additional_section'
		)
	);

	/*Archive Post Options*/
	$wp_customize->add_section('solar_generator_blog_post_section', array(
		'priority'       => 5,
		'capability'     => 'edit_theme_options',
		'theme_supports' => '',
		'title'          => __('Blog Page Options', 'solar-generator'),
		'panel'       => 'solar_generator_panel',
	));

	$wp_customize->add_setting('solar_generator_enable_blog_post_title',array(
		'capability'        => 'edit_theme_options',
		'transport'         => 'refresh',
		'default'           => 1,
		'sanitize_callback' => 'solar_generator_sanitize_checkbox',
	));
	$wp_customize->add_control('solar_generator_enable_blog_post_title',array(
		'label'       => __('Enable Blog Post Title', 'solar-generator'),
		'description' => __('Checked To Show Blog Post Title', 'solar-generator'),
		'section'     => 'solar_generator_blog_post_section',
		'type'        => 'checkbox',
	));

	$wp_customize->add_setting('solar_generator_enable_blog_post_meta',array(
		'capability'        => 'edit_theme_options',
		'transport'         => 'refresh',
		'default'           => 1,
		'sanitize_callback' => 'solar_generator_sanitize_checkbox',
	));
	$wp_customize->add_control('solar_generator_enable_blog_post_meta',array(
		'label'       => __('Enable Blog Post Meta', 'solar-generator'),
		'description' => __('Checked To Show Blog Post Meta Feilds', 'solar-generator'),
		'section'     => 'solar_generator_blog_post_section',
		'type'        => 'checkbox',
	));

	$wp_customize->add_setting('solar_generator_enable_blog_post_tags',array(
		'capability'        => 'edit_theme_options',
		'transport'         => 'refresh',
		'default'           => 1,
		'sanitize_callback' => 'solar_generator_sanitize_checkbox',
	));
	$wp_customize->add_control('solar_generator_enable_blog_post_tags',array(
		'label'       => __('Enable Blog Post Tags', 'solar-generator'),
		'description' => __('Checked To Show Blog Post Tags', 'solar-generator'),
		'section'     => 'solar_generator_blog_post_section',
		'type'        => 'checkbox',
	));

	$wp_customize->add_setting('solar_generator_enable_blog_post_image',array(
		'capability'        => 'edit_theme_options',
		'transport'         => 'refresh',
		'default'           => 1,
		'sanitize_callback' => 'solar_generator_sanitize_checkbox',
	));
	$wp_customize->add_control('solar_generator_enable_blog_post_image',array(
		'label'       => __('Enable Blog Post Image', 'solar-generator'),
		'description' => __('Checked To Show Blog Post Image', 'solar-generator'),
		'section'     => 'solar_generator_blog_post_section',
		'type'        => 'checkbox',
	));

	$wp_customize->add_setting('solar_generator_enable_blog_post_content',array(
		'capability'        => 'edit_theme_options',
		'transport'         => 'refresh',
		'default'           => 1,
		'sanitize_callback' => 'solar_generator_sanitize_checkbox',
	));
	$wp_customize->add_control('solar_generator_enable_blog_post_content',array(
		'label'       => __('Enable Blog Post Content', 'solar-generator'),
		'description' => __('Checked To Show Blog Post Content', 'solar-generator'),
		'section'     => 'solar_generator_blog_post_section',
		'type'        => 'checkbox',
	));

	$wp_customize->add_setting('solar_generator_enable_blog_post_button',array(
		'capability'        => 'edit_theme_options',
		'transport'         => 'refresh',
		'default'           => 1,
		'sanitize_callback' => 'solar_generator_sanitize_checkbox',
	));
	$wp_customize->add_control('solar_generator_enable_blog_post_button',array(
		'label'       => __('Enable Blog Post Read More Button', 'solar-generator'),
		'description' => __('Checked To Show Blog Post Read More Button', 'solar-generator'),
		'section'     => 'solar_generator_blog_post_section',
		'type'        => 'checkbox',
	));

	/*Blog post Content layout*/
	$wp_customize->add_setting('solar_generator_blog_Post_content_layout',array(
        'default' => 'Left',
        'sanitize_callback' => 'solar_generator_sanitize_choices'
	));
	$wp_customize->add_control('solar_generator_blog_Post_content_layout',array(
        'type' => 'select',
        'label' => esc_html__('Blog Post Content Layout','solar-generator'),
        'section' => 'solar_generator_blog_post_section',
        'choices' => array(
            'Left' => esc_html__('Left','solar-generator'),
            'Center' => esc_html__('Center','solar-generator'),
            'Right' => esc_html__('Right','solar-generator')
        ),
	) );

	/*Excerpt*/
    $wp_customize->add_setting(
		'solar_generator_excerpt_limit',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => '25',
			'sanitize_callback' => 'sanitize_text_field',
		)
	);

	$wp_customize->add_control(
		'solar_generator_excerpt_limit',
		array(
			'label'       => __('Excerpt Limit', 'solar-generator'),
			'section'     => 'solar_generator_blog_post_section',
			'type'        => 'number',
			'input_attrs' => array(
	            'min' => 2,
	             'max' => 50,
	             'step' => 2,
	         ),
		)
	);

	/*Archive Button Text*/
	$wp_customize->add_setting(
		'solar_generator_read_more_text',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => 'Continue Reading....',
			'sanitize_callback' => 'sanitize_text_field',
		)
	);

	$wp_customize->add_control(
		'solar_generator_read_more_text',
		array(
			'label'       => __('Edit Button Text ', 'solar-generator'),
			'section'     => 'solar_generator_blog_post_section',
			'type'        => 'text',
		)
	);

	/*Single Post Options*/
	$wp_customize->add_section('solar_generator_single_post_section', array(
		'priority'       => 5,
		'capability'     => 'edit_theme_options',
		'theme_supports' => '',
		'title'          => __('Single Post Options', 'solar-generator'),
		'panel'       => 'solar_generator_panel',
	));

	$wp_customize->add_setting('solar_generator_enable_single_blog_post_title',array(
		'capability'        => 'edit_theme_options',
		'transport'         => 'refresh',
		'default'           => 1,
		'sanitize_callback' => 'solar_generator_sanitize_checkbox',
	));
	$wp_customize->add_control('solar_generator_enable_single_blog_post_title',array(
		'label'       => __('Enable Single Post Title', 'solar-generator'),
		'description' => __('Checked To Show Single Blog Post Title', 'solar-generator'),
		'section'     => 'solar_generator_single_post_section',
		'type'        => 'checkbox',
	));

	$wp_customize->add_setting('solar_generator_enable_single_blog_post_meta',array(
		'capability'        => 'edit_theme_options',
		'transport'         => 'refresh',
		'default'           => 1,
		'sanitize_callback' => 'solar_generator_sanitize_checkbox',
	));
	$wp_customize->add_control('solar_generator_enable_single_blog_post_meta',array(
		'label'       => __('Enable Single Post Meta', 'solar-generator'),
		'description' => __('Checked To Show Single Blog Post Meta Feilds', 'solar-generator'),
		'section'     => 'solar_generator_single_post_section',
		'type'        => 'checkbox',
	));

	$wp_customize->add_setting('solar_generator_enable_single_blog_post_tags',array(
		'capability'        => 'edit_theme_options',
		'transport'         => 'refresh',
		'default'           => 1,
		'sanitize_callback' => 'solar_generator_sanitize_checkbox',
	));
	$wp_customize->add_control('solar_generator_enable_single_blog_post_tags',array(
		'label'       => __('Enable Single Post Tags', 'solar-generator'),
		'description' => __('Checked To Show Single Blog Post Tags', 'solar-generator'),
		'section'     => 'solar_generator_single_post_section',
		'type'        => 'checkbox',
	));

	$wp_customize->add_setting('solar_generator_enable_single_post_image',array(
		'capability'        => 'edit_theme_options',
		'transport'         => 'refresh',
		'default'           => 1,
		'sanitize_callback' => 'solar_generator_sanitize_checkbox',
	));
	$wp_customize->add_control('solar_generator_enable_single_post_image',array(
		'label'       => __('Enable Single Post Image', 'solar-generator'),
		'description' => __('Checked To Show Single Post Image', 'solar-generator'),
		'section'     => 'solar_generator_single_post_section',
		'type'        => 'checkbox',
	));

	$wp_customize->add_setting('solar_generator_enable_single_blog_post_content',array(
		'capability'        => 'edit_theme_options',
		'transport'         => 'refresh',
		'default'           => 1,
		'sanitize_callback' => 'solar_generator_sanitize_checkbox',
	));
	$wp_customize->add_control('solar_generator_enable_single_blog_post_content',array(
		'label'       => __('Enable Single Post Content', 'solar-generator'),
		'description' => __('Checked To Show Single Blog Post Content', 'solar-generator'),
		'section'     => 'solar_generator_single_post_section',
		'type'        => 'checkbox',
	));

	/*Related Post Enable Option*/
	$wp_customize->add_setting(
		'solar_generator_enable_related_post',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => 1,
			'sanitize_callback' => 'solar_generator_sanitize_checkbox',
		)
	);

	$wp_customize->add_control(
		'solar_generator_enable_related_post',
		array(
			'label'       => __('Enable Related Post', 'solar-generator'),
			'description' => __('Checked to show Related Post', 'solar-generator'),
			'section'     => 'solar_generator_single_post_section',
			'type'        => 'checkbox',
		)
	);

	/*Related post Edit Text*/
	$wp_customize->add_setting(
		'solar_generator_related_post_text',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => 'Related Post',
			'sanitize_callback' => 'sanitize_text_field',
		)
	);

	$wp_customize->add_control(
		'solar_generator_related_post_text',
		array(
			'label'       => __('Edit Related Post Text ', 'solar-generator'),
			'section'     => 'solar_generator_single_post_section',
			'type'        => 'text',
		)
	);	

	/*Related Post Per Page*/
	$wp_customize->add_setting(
		'solar_generator_related_post_count',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => '3',
			'sanitize_callback' => 'sanitize_text_field',
		)
	);

	$wp_customize->add_control(
		'solar_generator_related_post_count',
		array(
			'label'       => __('Related Post Count', 'solar-generator'),
			'section'     => 'solar_generator_single_post_section',
			'type'        => 'number',
			'input_attrs' => array(
	            'min' => 1,
	             'max' => 9,
	             'step' => 1,
	         ),
		)
	);

	/* Comment Section Enable Option*/
	$wp_customize->add_setting(
		'solar_generator_enable_comment_section',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => 1,
			'sanitize_callback' => 'solar_generator_sanitize_checkbox',
		)
	);

	$wp_customize->add_control(
		'solar_generator_enable_comment_section',
		array(
			'label'       => __('Enable Comment Section', 'solar-generator'),
			'description' => __('Checked to show Comment Section', 'solar-generator'),
			'section'     => 'solar_generator_single_post_section',
			'type'        => 'checkbox',
		)
	);

		/*
	* Customizer Global COlor
	*/

	/*Global Color Options*/
	$wp_customize->add_section('solar_generator_global_color_section', array(
		'priority'       => 1,
		'capability'     => 'edit_theme_options',
		'theme_supports' => '',
		'title'          => __('Global Color Options', 'solar-generator'),
		'panel'       => 'solar_generator_panel',
	));

	$wp_customize->add_setting( 'solar_generator_primary_color',
		array(
		'default'           => '#539D56',
		'capability'        => 'edit_theme_options',
		'sanitize_callback' => 'sanitize_hex_color',
		)
	);
	$wp_customize->add_control( 
		new WP_Customize_Color_Control( 
		$wp_customize, 
		'solar_generator_primary_color',
		array(
			'label'      => esc_html__( 'Primary Color', 'solar-generator' ),
			'section'    => 'solar_generator_global_color_section',
			'settings'   => 'solar_generator_primary_color',
		) ) 
	);

	/*Typography Options*/
	$wp_customize->add_section( 'solar_generator_typography_section', array(
		'panel'       => 'solar_generator_panel',
        'title'    => __( 'Typography Options', 'solar-generator' ),
        'priority' => 2,
    ) );

    $wp_customize->add_setting( 'solar_generator_font_family', array(
		'default'           => 'default',
		'sanitize_callback' => 'solar_generator_sanitize_font_family',
	) );
	
	$wp_customize->add_control( 'solar_generator_font_family', array(
		'label'    => __( 'Global Font Family', 'solar-generator' ),
		'section'  => 'solar_generator_typography_section',
		'type'     => 'select',
		'choices'  => array(
			'default'          => __( 'Default (Theme Font)', 'solar-generator' ),
			'bad_script'       => 'Bad Script',
			'roboto'           => 'Roboto',
			'playfair_display' => 'Playfair Display',
			'open_sans'        => 'Open Sans',
			'lobster'          => 'Lobster',
			'merriweather'     => 'Merriweather',
			'oswald'           => 'Oswald',
			'raleway'          => 'Raleway',
		),
	) );

		
	/*Main Header Options*/
	$wp_customize->add_section('solar_generator_header_section', array(
		'priority'       => 5,
		'capability'     => 'edit_theme_options',
		'theme_supports' => '',
		'title'          => __('Main Header Options', 'solar-generator'),
		'panel'       => 'solar_generator_panel',
	));

	/*
	* Customizer main header section
	*/

	/*Main Header Options*/
	$wp_customize->add_section('solar_generator_header_section', array(
		'priority'       => 5,
		'capability'     => 'edit_theme_options',
		'theme_supports' => '',
		'title'          => __('Main Header Options', 'solar-generator'),
		'panel'       => 'solar_generator_panel',
	));

	$wp_customize->add_setting(
		'solar_generator_header_search',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => true,
			'sanitize_callback' => 'solar_generator_sanitize_checkbox',
		)
	);

	$wp_customize->add_control(
		'solar_generator_header_search',
		array(
			'label'       => __('Enable Disable Search', 'solar-generator'),
			'description' => __('Enable or Disable header Search', 'solar-generator'),
			'section'     => 'solar_generator_header_section',
			'type'        => 'checkbox',
		)
	);

	// Add Setting for Menu Text Transform
    $wp_customize->add_setting( 'solar_generator_menu_text_transform', array(
		'capability'        => 'edit_theme_options',
		'transport'         => 'refresh',
		'default'           => 'capitalize',
        'sanitize_callback' => 'solar_generator_sanitize_choices'
    ) );

    // Add Control for Menu Text Transform
    $wp_customize->add_control( 'solar_generator_menu_text_transform', array(
        'label'    => __( 'Menu Text Transform', 'solar-generator' ),
        'section'  => 'solar_generator_header_section',
        'type'     => 'select',
        'choices'  => array(
            'none'       => __( 'None', 'solar-generator' ),
            'capitalize' => __( 'Capitalize', 'solar-generator' ),
            'uppercase'  => __( 'Uppercase', 'solar-generator' ),
            'lowercase'  => __( 'Lowercase', 'solar-generator' ),
        ),
    ) );

	/*Main Header Phone Text*/
	$wp_customize->add_setting(
		'solar_generator_header_info_phone',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => 'Toll Free: +1234-567-7890',
			'sanitize_callback' => 'sanitize_text_field',
		)
	);
	$wp_customize->add_control(
		'solar_generator_header_info_phone',
		array(
			'label'       => __('Edit Phone Number ', 'solar-generator'),
			'section'     => 'solar_generator_header_section',
			'type'        => 'text',
		)
	);

	/*Main Header Phone Text*/
	$wp_customize->add_setting(
		'solar_generator_header_info_email',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => 'solar123456@example.com',
			'sanitize_callback' => 'sanitize_text_field',
		)
	);
	$wp_customize->add_control(
		'solar_generator_header_info_email',
		array(
			'label'       => __('Edit Email Address ', 'solar-generator'),
			'section'     => 'solar_generator_header_section',
			'type'        => 'text',
		)
	);

	/*Facebook Link*/
	$wp_customize->add_setting(
		'solar_generator_facebook_link_option',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => '#',
			'sanitize_callback' => 'esc_url_raw',
		)
	);

	$wp_customize->add_control(
		'solar_generator_facebook_link_option',
		array(
			'label'       => __('Edit Facebook Link', 'solar-generator'),
			'section'     => 'solar_generator_header_section',
			'type'        => 'url',
		)
	);

	/*Twitter Link*/
	$wp_customize->add_setting(
		'solar_generator_twitter_link_option',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => '#',
			'sanitize_callback' => 'esc_url_raw',
		)
	);

	$wp_customize->add_control(
		'solar_generator_twitter_link_option',
		array(
			'label'       => __('Edit Twitter Link', 'solar-generator'),
			'section'     => 'solar_generator_header_section',
			'type'        => 'url',
		)
	);

	/*Instagram Link*/
	$wp_customize->add_setting(
		'solar_generator_instagram_link_option',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => '#',
			'sanitize_callback' => 'esc_url_raw',
		)
	);

	$wp_customize->add_control(
		'solar_generator_instagram_link_option',
		array(
			'label'       => __('Edit Instagram Link', 'solar-generator'),
			'section'     => 'solar_generator_header_section',
			'type'        => 'url',
		)
	);

	/*linked Link*/
	$wp_customize->add_setting(
		'solar_generator_linkedin_link_option',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => '#',
			'sanitize_callback' => 'esc_url_raw',
		)
	);
	$wp_customize->add_control(
		'solar_generator_linkedin_link_option',
		array(
			'label'       => __('Edit Linkedin Link', 'solar-generator'),
			'section'     => 'solar_generator_header_section',
			'type'        => 'url',
		)
	);

	/*linked Link*/
	$wp_customize->add_setting(
		'solar_generator_pinterest_link_option',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => '#',
			'sanitize_callback' => 'esc_url_raw',
		)
	);
	$wp_customize->add_control(
		'solar_generator_pinterest_link_option',
		array(
			'label'       => __('Edit Pinterest Link', 'solar-generator'),
			'section'     => 'solar_generator_header_section',
			'type'        => 'url',
		)
	);

	$wp_customize->add_setting(
		'solar_generator_youtube_link_option',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => '#',
			'sanitize_callback' => 'esc_url_raw',
		)
	);
	$wp_customize->add_control(
		'solar_generator_youtube_link_option',
		array(
			'label'       => __('Edit Youtube Link', 'solar-generator'),
			'section'     => 'solar_generator_header_section',
			'type'        => 'url',
		)
	);

	/*Main Header Button Text*/
	$wp_customize->add_setting(
		'solar_generator_header_button_text',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => 'Get A Quote',
			'sanitize_callback' => 'sanitize_text_field',
		)
	);

	$wp_customize->add_control(
		'solar_generator_header_button_text',
		array(
			'label'       => __('Edit Button Text ', 'solar-generator'),
			'section'     => 'solar_generator_header_section',
			'type'        => 'text',
		)
	);

	/*Main Header Button Link*/
	$wp_customize->add_setting(
		'solar_generator_header_button_link',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => '',
			'sanitize_callback' => 'esc_url_raw',
		)
	);

	$wp_customize->add_control(
		'solar_generator_header_button_link',
		array(
			'label'       => __('Edit Button Link ', 'solar-generator'),
			'section'     => 'solar_generator_header_section',
			'type'        => 'url',
		)
	);

	$wp_customize->add_setting( 
		'solar_generator_header_settings_upgraded_features',
		array(
			'sanitize_callback' => 'sanitize_text_field'
		)
	);

	$wp_customize->add_control(
		'solar_generator_header_settings_upgraded_features', 
		array(
			'type'=> 'hidden',
			'description' => "
				<div class='customizer-upgraded-features'>
					<span class='pro-head'>Want more header options?</span><br/>
					<span class='pro-text'>						
						<a target='_blank' href='". esc_url(SOLAR_GENERATOR_BUY_NOW) ." '>Check Solar Generator PRO version.</a>
					</div>
				</div>
			",
			'section' => 'solar_generator_header_section'
		)
	);

	/*
	* Customizer main slider section
	*/
	/*Main Slider Options*/
	$wp_customize->add_section('solar_generator_slider_section', array(
		'priority'       => 5,
		'capability'     => 'edit_theme_options',
		'theme_supports' => '',
		'title'          => __('Main Slider Options', 'solar-generator'),
		'panel'       => 'solar_generator_panel',
	));

	/*Main Slider Enable Option*/
	$wp_customize->add_setting(
		'solar_generator_enable_slider',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => 0,
			'sanitize_callback' => 'solar_generator_sanitize_checkbox',
		)
	);

	$wp_customize->add_control(
		'solar_generator_enable_slider',
		array(
			'label'       => __('Enable Main Slider', 'solar-generator'),
			'description' => __('Checked to show the main slider', 'solar-generator'),
			'section'     => 'solar_generator_slider_section',
			'type'        => 'checkbox',
		)
	);

	for ($i=1; $i <= 3; $i++) { 

		/*Main Slider Image*/
		$wp_customize->add_setting(
			'solar_generator_slider_image'.$i,
			array(
				'capability'    => 'edit_theme_options',
		        'default'       => '',
		        'transport'     => 'postMessage',
		        'sanitize_callback' => 'esc_url_raw',
	    	)
	    );

		$wp_customize->add_control( 
			new WP_Customize_Image_Control( $wp_customize, 
				'solar_generator_slider_image'.$i, 
				array(
			        'label' => __('Edit Slider Image ', 'solar-generator') .$i,
			        'description' => __('Edit the slider image.', 'solar-generator'),
			        'section' => 'solar_generator_slider_section',
				)
			)
		);

		/*Main Slider Heading*/
		$wp_customize->add_setting(
			'solar_generator_slider_top_text'.$i,
			array(
				'capability'        => 'edit_theme_options',
				'transport'         => 'refresh',
				'default'           => '',
				'sanitize_callback' => 'sanitize_text_field',
			)
		);

		$wp_customize->add_control(
			'solar_generator_slider_top_text'.$i,
			array(
				'label'       => __('Edit Slider Top Text ', 'solar-generator') .$i,
				'description' => __('Edit the slider Top text.', 'solar-generator'),
				'section'     => 'solar_generator_slider_section',
				'type'        => 'text',
			)
		);

		/*Main Slider Heading*/
		$wp_customize->add_setting(
			'solar_generator_slider_heading'.$i,
			array(
				'capability'        => 'edit_theme_options',
				'transport'         => 'refresh',
				'default'           => '',
				'sanitize_callback' => 'sanitize_text_field',
			)
		);

		$wp_customize->add_control(
			'solar_generator_slider_heading'.$i,
			array(
				'label'       => __('Edit Heading Text ', 'solar-generator') .$i,
				'description' => __('Edit the slider heading text.', 'solar-generator'),
				'section'     => 'solar_generator_slider_section',
				'type'        => 'text',
			)
		);

		/*Main Slider Content*/
		$wp_customize->add_setting(
			'solar_generator_slider_text'.$i,
			array(
				'capability'        => 'edit_theme_options',
				'transport'         => 'refresh',
				'default'           => '',
				'sanitize_callback' => 'sanitize_text_field',
			)
		);

		$wp_customize->add_control(
			'solar_generator_slider_text'.$i,
			array(
				'label'       => __('Edit Content Text ', 'solar-generator') .$i,
				'description' => __('Edit the slider content text.', 'solar-generator'),
				'section'     => 'solar_generator_slider_section',
				'type'        => 'text',
			)
		);

		/*Main Slider Button1 Text*/
		$wp_customize->add_setting(
			'solar_generator_slider_button1_text'.$i,
			array(
				'capability'        => 'edit_theme_options',
				'transport'         => 'refresh',
				'default'           => '',
				'sanitize_callback' => 'sanitize_text_field',
			)
		);
		$wp_customize->add_control(
			'solar_generator_slider_button1_text'.$i,
			array(
				'label'       => __('Edit Button #1 Text ', 'solar-generator') .$i,
				'description' => __('Edit the slider button text.', 'solar-generator'),
				'section'     => 'solar_generator_slider_section',
				'type'        => 'text',
			)
		);

		/*Main Slider Button1 URL*/
		$wp_customize->add_setting(
			'solar_generator_slider_button1_link'.$i,
			array(
				'capability'        => 'edit_theme_options',
				'transport'         => 'refresh',
				'default'           => '',
				'sanitize_callback' => 'esc_url_raw',
			)
		);

		$wp_customize->add_control(
			'solar_generator_slider_button1_link'.$i,
			array(
				'label'       => __('Edit Button #1 URL ', 'solar-generator') .$i,
				'description' => __('Edit the slider button url.', 'solar-generator'),
				'section'     => 'solar_generator_slider_section',
				'type'        => 'url',
			)
		);

		/*Main Slider Button2 Text*/
		$wp_customize->add_setting(
			'solar_generator_slider_button2_text'.$i,
			array(
				'capability'        => 'edit_theme_options',
				'transport'         => 'refresh',
				'default'           => '',
				'sanitize_callback' => 'sanitize_text_field',
			)
		);

		$wp_customize->add_control(
			'solar_generator_slider_button2_text'.$i,
			array(
				'label'       => __('Edit Button #2 Text ', 'solar-generator') .$i,
				'description' => __('Edit the slider button text.', 'solar-generator'),
				'section'     => 'solar_generator_slider_section',
				'type'        => 'text',
			)
		);

		/*Main Slider Button1 URL*/
		$wp_customize->add_setting(
			'solar_generator_slider_button2_link'.$i,
			array(
				'capability'        => 'edit_theme_options',
				'transport'         => 'refresh',
				'default'           => '',
				'sanitize_callback' => 'esc_url_raw',
			)
		);

		$wp_customize->add_control(
			'solar_generator_slider_button2_link'.$i,
			array(
				'label'       => __('Edit Button #2 URL ', 'solar-generator') .$i,
				'description' => __('Edit the slider button url.', 'solar-generator'),
				'section'     => 'solar_generator_slider_section',
				'type'        => 'url',
			)
		);
	}

	$wp_customize->add_setting( 
		'solar_generator_slider_settings_upgraded_features',
		array(
			'sanitize_callback' => 'sanitize_text_field'
		)
	);

	$wp_customize->add_control(
		'solar_generator_slider_settings_upgraded_features', 
		array(
			'type'=> 'hidden',
			'description' => "
				<div class='customizer-upgraded-features'>
					<span class='pro-head'>Want more slider options?</span><br/>
					<span class='pro-text'>						
						<a target='_blank' href='". esc_url(SOLAR_GENERATOR_BUY_NOW) ." '>Check Solar Generator PRO version.</a>
					</div>
				</div>
			",
			'section' => 'solar_generator_slider_section'
		)
	);

	// Project section
	$wp_customize->add_section('solar_generator_projetcs_sec', array(
	    'priority'       => 5,
	    'capability'     => 'edit_theme_options',
	    'title'          => __('Our Best Project Section', 'solar-generator'),
	    'panel'          => 'solar_generator_panel',
	));

	// Enable/disable section
	$wp_customize->add_setting('solar_generator_projetcs_sec_show', array(
	    'capability'        => 'edit_theme_options',
	    'default'           => 0,
	    'sanitize_callback' => 'solar_generator_sanitize_checkbox',
	));

	$wp_customize->add_control('solar_generator_projetcs_sec_show', array(
	    'label'    => __('Enable Our Projects Section', 'solar-generator'),
	    'section'  => 'solar_generator_projetcs_sec',
	    'type'     => 'checkbox',
	));

	// Section heading text
	$wp_customize->add_setting('solar_generator_projetcs_main_text', array(
	    'default'           => '',
	    'sanitize_callback' => 'sanitize_text_field',
	));

	$wp_customize->add_control('solar_generator_projetcs_main_text', array(
	    'label'   => esc_html__('Add Section Small Title', 'solar-generator'),
	    'section' => 'solar_generator_projetcs_sec',
	    'type'    => 'text',
	));

	// Section heading
	$wp_customize->add_setting('solar_generator_projetcs_main_heading', array(
	    'default'           => '',
	    'sanitize_callback' => 'sanitize_text_field',
	));

	$wp_customize->add_control('solar_generator_projetcs_main_heading', array(
	    'label'   => esc_html__('Add Section Small Heading', 'solar-generator'),
	    'section' => 'solar_generator_projetcs_sec',
	    'type'    => 'text',
	));

	// Number of tabs
	$wp_customize->add_setting('solar_generator_projetcs_number', array(
	    'default'           => 6,
	    'sanitize_callback' => 'absint',
	));

	$wp_customize->add_control('solar_generator_projetcs_number', array(
	    'label'       => esc_html__('No of Tabs to show', 'solar-generator'),
	    'section'     => 'solar_generator_projetcs_sec',
	    'type'        => 'number',
	    'input_attrs' => array(
	        'step' => 1,
	        'min'  => 0,
	        'max'  => 6,
	    ),
	));

	// Dynamically adding tabs
	$featured_post = absint(get_theme_mod('solar_generator_projetcs_number', 6));
	for ( $j = 1; $j <= $featured_post; $j++ ) {
	    $wp_customize->add_setting('solar_generator_projetcs_text'.$j, array(
		    'default'           => '',
		    'sanitize_callback' => 'sanitize_text_field',
		));
		$wp_customize->add_control('solar_generator_projetcs_text'.$j, array(
		    'label'   => esc_html__('Edit Tab Text ', 'solar-generator').$j, 
		    'section' => 'solar_generator_projetcs_sec',
		    'type'    => 'text',
		));

	    $categories = get_categories();
	    $cat_posts = array('select' => 'Select');
	    foreach ($categories as $category) {
	        $cat_posts[$category->slug] = $category->name;
	    }

	    $wp_customize->add_setting('solar_generator_projetcs_category'.$j, array(
	        'default'           => 'uncategorized',
	        'sanitize_callback' => 'solar_generator_sanitize_choices',
	    ));

	    $wp_customize->add_control('solar_generator_projetcs_category'.$j, array(
	        'type'    => 'select',
	        'choices' => $cat_posts,
	        'label'   => __('Select Category to display projects', 'solar-generator'),
	        'section' => 'solar_generator_projetcs_sec',
	    ));
	}

	$wp_customize->add_setting( 
		'solar_generator_projetcs_settings_upgraded_features',
		array(
			'sanitize_callback' => 'sanitize_text_field'
		)
	);

	$wp_customize->add_control(
		'solar_generator_projetcs_settings_upgraded_features', 
		array(
			'type'=> 'hidden',
			'description' => "
				<div class='customizer-upgraded-features'>
					<span class='pro-head'>Want more projetcs options?</span><br/>
					<span class='pro-text'>						
						<a target='_blank' href='". esc_url(SOLAR_GENERATOR_BUY_NOW) ." '>Check Solar Generator PRO version.</a>
					</div>
				</div>
			",
			'section' => 'solar_generator_projetcs_sec'
		)
	);

	/*
	* Customizer Footer Section
	*/
	/*Footer Options*/
	$wp_customize->add_section('solar_generator_footer_section', array(
		'priority'       => 5,
		'capability'     => 'edit_theme_options',
		'theme_supports' => '',
		'title'          => __('Footer Options', 'solar-generator'),
		'panel'       => 'solar_generator_panel',
	));

	/*Footer Enable Option*/
	$wp_customize->add_setting(
		'solar_generator_enable_footer',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => 1,
			'sanitize_callback' => 'solar_generator_sanitize_checkbox',
		)
	);
	$wp_customize->add_control(
		'solar_generator_enable_footer',
		array(
			'label'       => __('Enable Footer', 'solar-generator'),
			'description' => __('Checked to show Footer', 'solar-generator'),
			'section'     => 'solar_generator_footer_section',
			'type'        => 'checkbox',
		)
	);

	/*Footer bg image Option*/
	$wp_customize->add_setting('solar_generator_footer_bg_image',array(
		'capability'        => 'edit_theme_options',
		'transport'         => 'refresh',
        'default'           => '',
        'sanitize_callback' => 'esc_url_raw',
    ));
    $wp_customize->add_control( new WP_Customize_Image_Control($wp_customize,'solar_generator_footer_bg_image',array(
        'label' => __('Footer Background Image','solar-generator'),
        'section' => 'solar_generator_footer_section',
    )));


	/** Footer bg Image Attachment */
    $wp_customize->add_setting('solar_generator_background_attachment', array(
        'capability'        => 'edit_theme_options',
		'transport'         => 'refresh',
		'default'           => 'scroll',
        'sanitize_callback' => 'solar_generator_sanitize_choices'
    ));

    $wp_customize->add_control('solar_generator_background_attachment', array(
        'label'    => __('Footer Background Attachment', 'solar-generator'),
        'section'  => 'solar_generator_footer_section',
        'settings' => 'solar_generator_background_attachment',
        'type'     => 'select',
        'choices'  => array(
            'fixed' => __('fixed','solar-generator'),
            'scroll' => __('scroll','solar-generator'),
        ),
    ));

	/*Footer Social Menu Option*/
	$wp_customize->add_setting(
		'solar_generator_footer_social_menu',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => 1,
			'sanitize_callback' => 'solar_generator_sanitize_checkbox',
		)
	);

	$wp_customize->add_control(
		'solar_generator_footer_social_menu',
		array(
			'label'       => __('Enable Footer Social Menu', 'solar-generator'),
			'description' => __('Checked to show the footer social menu. Go to Dashboard >> Appearance >> Menus >> Create New Menu >> Add Custom Link >> Add Social Menu >> Checked Social Menu >> Save Menu.', 'solar-generator'),
			'section'     => 'solar_generator_footer_section',
			'type'        => 'checkbox',
		)
	);	

	/*Go To Top Option*/
	$wp_customize->add_setting(
		'solar_generator_enable_go_to_top_option',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => 1,
			'sanitize_callback' => 'solar_generator_sanitize_checkbox',
		)
	);

	$wp_customize->add_control(
		'solar_generator_enable_go_to_top_option',
		array(
			'label'       => __('Enable Go To Top', 'solar-generator'),
			'description' => __('Checked to enable Go To Top option.', 'solar-generator'),
			'section'     => 'solar_generator_footer_section',
			'type'        => 'checkbox',
		)
	);

	$wp_customize->add_setting('solar_generator_go_to_top_position',array(
        'capability'        => 'edit_theme_options',
		'transport'         => 'refresh',
		'default'           => 'Right',
        'sanitize_callback' => 'solar_generator_sanitize_choices'
    ));
    $wp_customize->add_control('solar_generator_go_to_top_position',array(
        'type' => 'select',
        'section' => 'solar_generator_footer_section',
        'label' => esc_html__('Go To Top Positions','solar-generator'),
        'choices' => array(
            'Right' => __('Right','solar-generator'),
            'Left' => __('Left','solar-generator'),
            'Center' => __('Center','solar-generator')
        ),
    ) );

	/*Footer Copyright Text Enable*/
	$wp_customize->add_setting(
		'solar_generator_copyright_option',
		array(
			'capability'        => 'edit_theme_options',
			'transport'         => 'refresh',
			'default'           => '',
			'sanitize_callback' => 'sanitize_text_field',
		)
	);

	$wp_customize->add_control(
		'solar_generator_copyright_option',
		array(
			'label'       => __('Edit Copyright Text', 'solar-generator'),
			'description' => __('Edit the Footer Copyright Section.', 'solar-generator'),
			'section'     => 'solar_generator_footer_section',
			'type'        => 'text',
		)
	);

	$wp_customize->add_setting( 
		'solar_generator_footer_settings_upgraded_features',
		array(
			'sanitize_callback' => 'sanitize_text_field'
		)
	);

	$wp_customize->add_control(
		'solar_generator_footer_settings_upgraded_features', 
		array(
			'type'=> 'hidden',
			'description' => "
				<div class='customizer-upgraded-features'>
					<span class='pro-head'>Want more footer options?</span><br/>
					<span class='pro-text'>						
						<a target='_blank' href='". esc_url(SOLAR_GENERATOR_BUY_NOW) ." '>Check Solar Generator PRO version.</a>
					</div>
				</div>
			",
			'section' => 'solar_generator_footer_section'
		)
	);

}
add_action( 'customize_register', 'Solar_Generator_Customize_register' );

/**
 * Render the site title for the selective refresh partial.
 *
 * @return void
 */
function Solar_Generator_Customize_partial_blogname() {
	bloginfo( 'name' );
}

/**
 * Render the site tagline for the selective refresh partial.
 *
 * @return void
 */
function Solar_Generator_Customize_partial_blogdescription() {
	bloginfo( 'description' );
}

/**
 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously.
 */
function Solar_Generator_Customize_preview_js() {
	wp_enqueue_script( 'solar-generator-customizer', get_template_directory_uri() . '/js/customizer.js', array( 'customize-preview' ), SOLAR_GENERATOR_VERSION, true );
}
add_action( 'customize_preview_init', 'Solar_Generator_Customize_preview_js' );

/**
 * Singleton class for handling the theme's customizer integration.
 *
 * @since  1.0.0
 * @access public
 */
final class Solar_Generator_Customize {

	/**
	 * Returns the instance.
	 *
	 * @since  1.0.0
	 * @access public
	 * @return object
	 */
	public static function get_instance() {

		static $solar_generator_instance = null;

		if ( is_null( $solar_generator_instance ) ) {
			$solar_generator_instance = new self;
			$solar_generator_instance->setup_actions();
		}

		return $solar_generator_instance;
	}

	/**
	 * Constructor method.
	 *
	 * @since  1.0.0
	 * @access private
	 * @return void
	 */
	private function __construct() {}

	/**
	 * Sets up initial actions.
	 *
	 * @since  1.0.0
	 * @access private
	 * @return void
	 */
	private function setup_actions() {

		// Register panels, sections, settings, controls, and partials.
		add_action( 'customize_register', array( $this, 'sections' ) );

		// Register scripts and styles for the controls.
		add_action( 'customize_controls_enqueue_scripts', array( $this, 'enqueue_control_scripts' ), 0 );
	}

	/**
	 * Sets up the customizer sections.
	 *
	 * @since  1.0.0
	 * @access public
	 * @param  object  $solar_generator_manager
	 * @return void
	*/
	public function sections( $solar_generator_manager ) {
		// Load custom sections.
		load_template( trailingslashit( get_template_directory() ) . '/revolution/inc/section-pro.php' );

		// Register custom section types.
		$solar_generator_manager->register_section_type( 'Solar_Generator_Customize_Section_Pro' );

		// Register sections.
		$solar_generator_manager->add_section( new Solar_Generator_Customize_Section_Pro( $solar_generator_manager,'solar_generator_go_pro', array(
			'priority'   => 1,
			'title'    => esc_html__( 'Solar Generator Pro', 'solar-generator' ),
			'pro_text' => esc_html__( 'Buy Pro', 'solar-generator' ),
			'pro_url'    => esc_url( SOLAR_GENERATOR_BUY_NOW ),
		) )	);

		// Register sections.
		$solar_generator_manager->add_section( new Solar_Generator_Customize_Section_Pro( $solar_generator_manager,'solar_generator_lite_documentation', array(
			'priority'   => 1,
			'title'    => esc_html__( 'Lite Documentation', 'solar-generator' ),
			'pro_text' => esc_html__( 'Instruction', 'solar-generator' ),
			'pro_url'    => esc_url( SOLAR_GENERATOR_LITE_DOC ),
		) )	);

		$solar_generator_manager->add_section( new Solar_Generator_Customize_Section_Pro( $solar_generator_manager, 'solar_generator_live_demo', array(
		    'priority'   => 1,
		    'title'      => esc_html__( 'Pro Theme Demo', 'solar-generator' ),
		    'pro_text'   => esc_html__( 'Live Preview', 'solar-generator' ),
		    'pro_url'    => esc_url( SOLAR_GENERATOR_LIVE_DEMO ),
		) ) );

		// Register sections.
		$solar_generator_manager->add_section( new Solar_Generator_Customize_Section_Pro( $solar_generator_manager, 'solar_generator_bundle', array(
			'priority'   => 1,
			'title'      => esc_html__( 'Theme Bundle', 'solar-generator' ),
			'pro_text'   => esc_html__( 'Get Bundle', 'solar-generator' ),
			'pro_url'    => esc_url( SOLAR_GENERATOR_BUNDLE ),
		) ) );	

	}

	/**
	 * Loads theme customizer CSS.
	 *
	 * @since  1.0.0
	 * @access public
	 * @return void
	 */
	public function enqueue_control_scripts() {

		wp_enqueue_script( 'solar-generator-customize-controls', trailingslashit( get_template_directory_uri() ) . '/revolution/assets/js/customize-controls.js', array( 'customize-controls' ) );

		wp_enqueue_style( 'solar-generator-customize-controls', trailingslashit( get_template_directory_uri() ) . '/revolution/assets/css/customize-controls.css' );
	}
}

// Doing this customizer thang!
Solar_Generator_Customize::get_instance();